<template>
  <v-container
    fluid
    tag="section"
  >
    <material-card
      icon="mdi-handshake"
      icon-small
      :title="$t('nuevaRecepcion')"
      color="secondary"
    >
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <RecepcionForm
            ref="recepcionForm"
            :recepcion="recepcionData"
            @onRecepcionGuardada="recepcionGuardada"
            @onCancelarGuardar="cancelarGuardado"
            @onTerminarRecepcion="terminarRecepcion"
          />
          <v-card-text style="height: 0px; position: relative">
            <v-fab-transition>
              <v-btn
                v-if="recepcionId > 0"
                color="accent"
                dark
                absolute
                top
                right
                fab
                @click="abrirDetalles"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </v-fab-transition>
          </v-card-text>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <DetalleRecepcionTabla
            ref="detalleTabla"
            :recepcionId="recepcionId"
            class="pl-4 pr-4"
          />
        </v-col>
      </v-row>
    </material-card>

    <v-navigation-drawer
      v-model="drawer"
      absolute
      temporary
      right
      width="60%"
      class="pt-2"
    >
      <v-card flat>
        <h2 class="pl-4 pb-4"> {{ $t('compras') }} </h2>
        <ComprasTabla
          v-if="recepcionId > 0"
          :esCompra="true"
          class="pt-2 pl-2"
          @onAgregarCompra="agregarCompra"
        />
      </v-card>
      <v-divider></v-divider>

    </v-navigation-drawer>
  </v-container>
</template>

<script>
import RecepcionForm from '@/components/Recepciones/RecepcionForm'
import DetalleRecepcionTabla from '@/components/Recepciones/DetalleRecepcionTabla'
import ComprasTabla from '@/components/Compras/ComprasTabla'
import RecepcionServicio from '@/store/services/RecepcionServicio'
export default {
  name: 'VistaNuevaRecepcion',
  components: {
    RecepcionForm,
    DetalleRecepcionTabla,
    ComprasTabla
  },
  props: {
  },
  data () {
    return {
      modal: false,
      recepcionData: null,
      drawer: false,
      recepcionId: 0,
      dato: null
    }
  },
  methods: {
    recepcionGuardada(value) {
      console.log(value)
      this.recepcionId = value.id
    },
    cancelarGuardado() {
      this.resetVistaRecepcion()
    },
    abrirDetalles() {
      this.drawer = true
    },
    guardarDetalle() {

    },
    agregarPedido(value)
    {
      this.guardarPedido(value)
    },
    async guardarPedido(value) {
      if (this.validarPedido(value)) {
        let response = await RecepcionServicio.asignCompra(value.id, this.recepcionId)
            this.$refs.detalleTabla.refreshTable()
        console.log(response)
      }
    },
    validarPedido(pedido) {
      let estado = true
      if (pedido.estado !== 'APROBADO' && pedido.autorizador_id !== null) {
        estado = false
        console.log("Hello");
        setTimeout(() => {  console.log("World!"); }, 2000);
        alert(this.$t('elPedidoDebeSerAprobado'))
      }
      return estado
    },
    terminarRecepcion() {
      this.resetVistaRecepcion()
    },
    resetVistaRecepcion()
    {
      this.recepcionId = 0
      this.$refs.recepcionForm.resetData()
      this.$refs.detalleTabla.refreshTable()
    },
    async agregarCompra(value) {
      try {
        let response = await RecepcionServicio.asignCompra(this.recepcionId, value.id)
        this.$refs.detalleTabla.refreshTable()
        console.log(response)
      } catch (error) {
        console.log(error)
      }
    }
  }
}
</script>

<style>

</style>
